#
# Find SDDS includes and library
#
# SDDS_INCLUDE_DIR - where to find SDDS.h, SDDStypes.h
# SDDS_LIBRARY     - qualified libraries to link against.
# SDDS_FOUND       - do not attempt to use if "no" or undefined.

SET(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a ${CMAKE_FIND_LIBRARY_SUFFIXES})

FIND_PATH(SDDS_INCLUDE_DIR SDDS.h
    HINTS $ENV{SDDS_INCLUDE_PATH} $ENV{SDDS_INCLUDE_DIR} $ENV{SDDS_PREFIX}/include $ENV{SDDS_DIR}/include $ENV{SDDS}/include
    PATHS ENV C_INCLUDE_PATH
)

FIND_PATH(SDDS_LIBRARY_DIR libSDDS1.a
    HINTS $ENV{SDDS_LIBRARY_PATH} $ENV{SDDS_LIBRARY_DIR} $ENV{SDDS_PREFIX}/lib $ENV{SDDS_DIR}/lib $ENV{SDDS}/lib
    PATHS ENV LIBRARY_PATH
)


IF(SDDS_INCLUDE_DIR AND SDDS_LIBRARY_DIR)
    SET( SDDS_FOUND "YES" )
ENDIF(SDDS_INCLUDE_DIR AND SDDS_LIBRARY_DIR)

IF (SDDS_FOUND)
   IF (NOT SDDS_FIND_QUIETLY)
      MESSAGE(STATUS "Found SDDS library dir: ${SDDS_LIBRARY_DIR}")
      MESSAGE(STATUS "Found SDDS include dir: ${SDDS_INCLUDE_DIR}")
   ENDIF (NOT SDDS_FIND_QUIETLY)
ELSE (SDDS_FOUND)
   IF (SDDS_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "Could not find SDDS!")
   ENDIF (SDDS_FIND_REQUIRED)
ENDIF (SDDS_FOUND)